﻿CREATE PROCEDURE "PMX_SP_CreateMoveOrder" (
	p_TransferNum nvarchar(50)
)
LANGUAGE SQLSCRIPT AS

BEGIN

	DECLARE v_returnDestinationBin nvarchar (50);
	DECLARE v_returnItem nvarchar (50);
	DECLARE v_returnItemDesc nvarchar (100);
	DECLARE v_returnItemUom nvarchar (100);
	DECLARE v_returnQuantity nvarchar (50);
	DECLARE v_returnSrcLocation nvarchar (50);
	DECLARE v_returnSrcLUID nvarchar (50);
	DECLARE v_returnQScode nvarchar (50);
	DECLARE v_v33CONTAINER nvarchar (100);
	DECLARE v_sampleQty INT;
	DECLARE v_remainingOpenQty INT;
	DECLARE v_warehouse nvarchar (100);
	DECLARE v_qcLocation nvarchar (100);
	DECLARE v_totalQtyWTQ INT;
	
	DECLARE v_tsNow DATETIME;
	DECLARE v_updateDate DATETIME;
	DECLARE v_updateTime INT;
	
	DECLARE v_moveDocEntry INT;
	
	v_sampleQty := 0;
	v_tsNow := CURRENT_TIMESTAMP;
	v_updateDate := TO_TIMESTAMP( TO_VARCHAR( v_tsNow, 'YYYY-MM-DD' ), 'YYYY-MM-DD' );
	v_updateTime := TO_INT( TO_VARCHAR( v_tsNow, 'HH24MI' ) );

	SELECT WTR1."ItemCode",OITM."ItemName",OITM."InvntryUom",WTR1."Quantity",WTR1."U_PMX_LOCO",WTR1."U_PMX_LUID",WTR1."U_PMX_QYSC", OWTR."U_V33_CONTAINER"
	,WTQ1."OpenQty"-WTR1."Quantity",WTR1."WhsCode", WTQ1."Quantity" 
	 ,CASE 
            	when ifnull(WTQ1."U_V33_SAMPLEQTY",0) > 0 then WTQ1."U_V33_SAMPLEQTY"
            	when ifnull(WTQ1."U_V33_SAMPLEPCT",0) > 0 then (WTQ1."Quantity"/100)*WTQ1."U_V33_SAMPLEPCT"
            	else 0
      END as "SampleQty"
	INTO v_returnItem,v_returnItemDesc,v_returnItemUom, v_returnQuantity, v_returnSrcLocation,v_returnSrcLUID,v_returnQScode,v_v33CONTAINER,
	v_remainingOpenQty,v_warehouse,v_totalQtyWTQ,v_sampleQty
	FROM owtr
	join wtr1 on WTR1."DocEntry" = OWTR."DocEntry"
	join OITM on OITM."ItemCode" = WTR1."ItemCode"
	join WTQ1 on WTQ1."DocEntry" = WTR1."BaseEntry" and WTQ1."LineNum" = WTR1."BaseLine"
	where OWTR."DocEntry" = p_TransferNum ;

	SELECT BinLocation INTO v_returnDestinationBin FROM "PMX_FN_GetNextLocation_PutAway" ( :v_returnItem);
	

		
	
	IF (v_remainingOpenQty<0 and v_sampleQty >0) THEN
		/*sample moves creation required*/
			IF (v_warehouse = 'QRM-WHS') THEN
			v_qcLocation := 'QRM-QA';
			END IF;
			IF (v_warehouse = 'CYN-WHS') THEN
			v_qcLocation := 'CYN-QA';
			END IF;
			IF (v_warehouse = 'XYG-WHS') THEN
			v_qcLocation := 'XYG-QA';
			END IF;
			
			/*full pallet put away MINUS sample qty */
			
			INSERT INTO PMX_MOHE ( "DocEntry", "Canceled","UserSign","CreateDate", "CreateTime","UpdateDate", "UpdateTime"
			, "Version", "ObjType", "Priority", "DocStatus", "MoveOrderType", "MoveOrderStatus", "DueDate",
			"LockedBy", "MoveLogUnitIn1Time","FromPmxWhsCode","ToPmxWhsCode", "Remarks" ) 
				VALUES ( "QCOSANDBOX".PMX_MOHE_S.nextval,'N','117', v_updateDate, v_updateTime,v_updateDate, v_updateTime, 
				1, 'PMX_MOHE', '200', 'O', 'M','N',v_updateDate,
				NULL,'N',v_warehouse,v_warehouse,v_v33CONTAINER);
			
			SELECT "QCOSANDBOX".PMX_MOHE_S.currval INTO v_moveDocEntry FROM dummy;
		
			INSERT INTO PMX_MOLI ( "InternalKey","DocEntry", "LineNum", "BaseType", "BaseEntry", "BaseLine", "LineStatus", "ItemCode", "Dscription","OpenQty","Quantity",
			"Uom", "QuantityPerUom","Version", "MoveOrderLineStatus","SrcStorLocCode","SrcLogUnitIdentKey","DestStorLocCode","DestLogUnitIdentKey"
			,"QualityStatusCode","QuantityUom2","Uom2","OpenQtyUom2","ItemTransactionalInfoKey","StockLevel","WABoxCode","Division","SrcMasterLogUnitIdentKey") 
			VALUES ( "QCOSANDBOX".PMX_MOLI_S.nextval,v_moveDocEntry,'0', NULL,NULL,NULL,'O', v_returnItem,v_returnItemDesc,v_returnQuantity-v_sampleQty,v_returnQuantity-v_sampleQty
			,v_returnItemUom,1,1,'O',v_returnSrcLocation,v_returnSrcLUID,v_returnDestinationBin,NULL,
			v_returnQScode,NULL,NULL,NULL,NULL,'D',NULL,NULL,NULL);

		/*sample qty put away*/
			
			INSERT INTO PMX_MOHE ( "DocEntry", "Canceled","UserSign","CreateDate", "CreateTime","UpdateDate", "UpdateTime"
			, "Version", "ObjType", "Priority", "DocStatus", "MoveOrderType", "MoveOrderStatus", "DueDate",
			"LockedBy", "MoveLogUnitIn1Time","FromPmxWhsCode","ToPmxWhsCode", "Remarks" ) 
				VALUES ( "QCOSANDBOX".PMX_MOHE_S.nextval,'N','117', v_updateDate, v_updateTime,v_updateDate, v_updateTime, 
				1, 'PMX_MOHE', '100', 'O', 'M','N',v_updateDate,
				NULL,'N',v_warehouse,v_warehouse,v_v33CONTAINER || '- QC');
			
			SELECT "QCOSANDBOX".PMX_MOHE_S.currval INTO v_moveDocEntry FROM dummy;
			
			INSERT INTO PMX_MOLI ( "InternalKey","DocEntry", "LineNum", "BaseType", "BaseEntry", "BaseLine", "LineStatus", "ItemCode", "Dscription","OpenQty","Quantity",
			"Uom", "QuantityPerUom","Version", "MoveOrderLineStatus","SrcStorLocCode","SrcLogUnitIdentKey","DestStorLocCode","DestLogUnitIdentKey"
			,"QualityStatusCode","QuantityUom2","Uom2","OpenQtyUom2","ItemTransactionalInfoKey","StockLevel","WABoxCode","Division","SrcMasterLogUnitIdentKey") 
			VALUES ( "QCOSANDBOX".PMX_MOLI_S.nextval,v_moveDocEntry,'0', NULL,NULL,NULL,'O', v_returnItem,v_returnItemDesc,v_sampleQty,v_sampleQty
			,v_returnItemUom,1,1,'O',v_returnSrcLocation,v_returnSrcLUID,v_qcLocation,NULL,
			v_returnQScode,NULL,NULL,NULL,NULL,'D',NULL,NULL,NULL);
	
	ELSE
		/*full pallet put away */
			INSERT INTO PMX_MOHE ( "DocEntry", "Canceled","UserSign","CreateDate", "CreateTime","UpdateDate", "UpdateTime"
			, "Version", "ObjType", "Priority", "DocStatus", "MoveOrderType", "MoveOrderStatus", "DueDate",
			"LockedBy", "MoveLogUnitIn1Time","FromPmxWhsCode","ToPmxWhsCode", "Remarks" ) 
				VALUES ( "QCOSANDBOX".PMX_MOHE_S.nextval,'N','117', v_updateDate, v_updateTime,v_updateDate, v_updateTime, 
				1, 'PMX_MOHE', '200', 'O', 'M','N',v_updateDate,
				NULL,'N',v_warehouse,v_warehouse,v_v33CONTAINER);
			
			SELECT "QCOSANDBOX".PMX_MOHE_S.currval INTO v_moveDocEntry FROM dummy;
		
			INSERT INTO PMX_MOLI ( "InternalKey","DocEntry", "LineNum", "BaseType", "BaseEntry", "BaseLine", "LineStatus", "ItemCode", "Dscription","OpenQty","Quantity",
			"Uom", "QuantityPerUom","Version", "MoveOrderLineStatus","SrcStorLocCode","SrcLogUnitIdentKey","DestStorLocCode","DestLogUnitIdentKey"
			,"QualityStatusCode","QuantityUom2","Uom2","OpenQtyUom2","ItemTransactionalInfoKey","StockLevel","WABoxCode","Division","SrcMasterLogUnitIdentKey") 
			VALUES ( "QCOSANDBOX".PMX_MOLI_S.nextval,v_moveDocEntry,'0', NULL,NULL,NULL,'O', v_returnItem,v_returnItemDesc,v_returnQuantity,v_returnQuantity
			,v_returnItemUom,1,1,'O',v_returnSrcLocation,v_returnSrcLUID,v_returnDestinationBin,NULL,
			v_returnQScode,NULL,NULL,NULL,NULL,'D',NULL,NULL,NULL);
			
	
	END IF;
	


END;